/****************************************************************************
 Include Section
*****************************************************************************/

#include "global.h"
#include "BfCacheTest.h"

#if defined __ICACHETEST__

/*****************************************************************************
 Symbolic constants / definitions
******************************************************************************/

/*****************************************************************************
 Variables
******************************************************************************/

/*****************************************************************************
 Prototypes
******************************************************************************/

.GLOBAL EXT_A;
.GLOBAL EXT_B;
.GLOBAL EXT_C;
.GLOBAL EXT_D;
.GLOBAL EXT_E;
.GLOBAL EXT_F;
.GLOBAL EXT_G;
.GLOBAL EXT_H;

/*****************************************************************************
 Functions
******************************************************************************/

.SECTION sdram;

/****************************************************************************
 Name:                  
 Description:           Cache Line Replacement Tests
                        All five functions are place at addresses that correspond
                        to the same Cache Line / Set by using "LDF_RESOLVE.h"
 Input Parameters:      none
 Return Parameters:     none
 Registers Used:        R7:0,P5:4,LC0/1,LT0/1,LB0/1
 Global Registers Used: none
 C-Callable :           no
*****************************************************************************/

EXT_A: // 17cycles, 32bytes
[--SP]=R0; // 1cycle, 2bytes
nop;R0=0;nop;R0=0;nop;R0=0;nop;R0=0;nop;R0=0;nop;R0=0;nop; // 13 cycles, 26bytes
R0=[SP++]; // 1cycle, 2bytes
rts; // 5cycles, 2bytes
EXT_A.end:

EXT_B:
[--SP]=R1;
nop;R1=1;nop;R1=1;nop;R1=1;nop;R1=1;nop;R1=1;nop;R1=1;nop;
R1=[SP++];
rts;
EXT_B.end:

EXT_C:
[--SP]=R2;
nop;R2=2;nop;R2=2;nop;R2=2;nop;R2=2;nop;R2=2;nop;R2=2;nop;
R2=[SP++];
rts;
EXT_C.end:

EXT_D:
[--SP]=R3;
nop;R3=3;nop;R3=3;nop;R3=3;nop;R3=3;nop;R3=3;nop;R3=3;nop;
R3=[SP++];
rts;
EXT_D.end:

EXT_E:
[--SP]=R4;
nop;R4=4;nop;R4=4;nop;R4=4;nop;R4=4;nop;R4=4;nop;R4=4;nop;
R4=[SP++];
rts;
EXT_E.end:

EXT_F:
[--SP]=R5;
nop;R5=5;nop;R5=5;nop;R5=5;nop;R5=5;nop;R5=5;nop;R5=5;nop;
R5=[SP++];
rts;
EXT_F.end:

EXT_G:
[--SP]=R6;
nop;R6=6;nop;R6=6;nop;R6=6;nop;R6=6;nop;R6=6;nop;R6=6;nop;
R6=[SP++];
rts;
EXT_G.end:

EXT_H:
[--SP]=R7;
nop;R7=7;nop;R7=7;nop;R7=7;nop;R7=7;nop;R7=7;nop;R7=7;nop;
R7=[SP++];
rts;
EXT_H.end:


#endif /* defined __ICACHETEST__ */

/*****************************************************************************
 EOF
******************************************************************************/
